﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using System;
using System.IO;

public class AccelerometerTranslate : MonoBehaviour
{
    public Transform movingObj;
	public ThreadSerialCommunication threadSerComm;
    ArduinoData arduinoData;
    
    float dt = 0f;
    float dt_prev = 0f;

    float x = 0f, v = 0f, a = 0f;

    // Start is called before the first frame update
    void Start()
    {
        x = movingObj.position.x;
    }

    // Update is called once per frame
    void Update()
    {
        threadSerComm.EnqueueOutput("1");
        arduinoData = threadSerComm.latestArduinoData;
        dt = Time.deltaTime;
        Vector3 acc_vec = new Vector3(arduinoData.acc_struct.x, arduinoData.acc_struct.y, 
                arduinoData.acc_struct.z);
        acc_vec = f_map(acc_vec, -8192, 8191, -2.0f, 2.0f);
        acc_vec = acc_vec * 9.81f;

        /* Debug.Log("x: " + arduinoData.acc_struct.x + "\ty: " + arduinoData.acc_struct.y + */
        /*         "\tz: " + arduinoData.acc_struct.z); */

        /* Debug.Log("x: " + acc_vec.x + "\ty: " + acc_vec.y + "\tz: " + acc_vec.z); */

        a = acc_vec.x;
        /* if (Mathf.Abs(a) <= 0.1) { */
        /*     a = 0; */
        /*     if (Mathf.Abs(v) > 0){ */
        /*         v -= 0.1f*dt; */
        /*     } */
        /* } else { */
        /*     Debug.Log(a); */
        /* } */
        v += a*dt;
        x += v*dt;

        Vector3 pos = movingObj.position;
        pos.x = x;
        movingObj.position = pos;
        dt_prev = dt;
    }

    Vector3 f_map(Vector3 x, int in_min, int in_max, float out_min, float out_max){
        Vector3 in_min_v = new Vector3(in_min, in_min, in_min);
        Vector3 in_max_v = new Vector3(in_min, in_max, in_max);
        Vector3 out_min_v = new Vector3(out_min, out_min, out_min);
        Vector3 map_val = (x - in_min_v) * (out_max - out_min)
              / (in_max - in_min) + out_min_v;
        return map_val;
    }
}
