﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

using System;
using System.IO;

public class PotentiometerTranslate : MonoBehaviour
{
    public Transform movingObj;
	public ThreadSerialCommunication threadSerComm;
    public float speed = 100f;
    ArduinoData arduinoData;
    
    int pot_val;
    int pot_min = 0, pot_max = 1023;
    float dt = 0f;
    float x0, x1, x_diff;
    float x_max, x_min;
    float x_range = 5f;

    // Start is called before the first frame update
    void Start()
    {
        x0 = movingObj.position.x;
        x_max = x0 + x_range;
        x_min = x0 - x_range;
        arduinoData = threadSerComm.latestArduinoData;
        pot_val = arduinoData.pot_val;

        /* x1 = f_map(pot_val, pot_min, pot_max, x_min, x_max); */

        /* Vector3 pos = movingObj.position; */
        /* pos.x = x1; */
        /* movingObj.position = pos; */
        /* x0 = x1; */
    }

    // Update is called once per frame
    void Update()
    {
        threadSerComm.EnqueueOutput("T1\0");
        arduinoData = threadSerComm.latestArduinoData;
        pot_val = arduinoData.pot_val;

        dt = Time.deltaTime;
        x1 = f_map(pot_val, pot_min, pot_max, x_min, x_max);
        Debug.Log("x: " + x1 + "\tpot_val: " + pot_val);
        x_diff = (x1 - x0)*speed*dt;

        Vector3 pos = movingObj.position;
        pos.x = x1;
        movingObj.position = pos;
        x0 = x1;

    }

    float f_map(int x, int in_min, int in_max, float out_min, float out_max){
        float map_val = (x - in_min) * (out_max - out_min)
              / (in_max - in_min) + out_min;
        return map_val;
    }
}
